import mpi
import sys

# -----------------------------------------------
# Record processor count
# -----------------------------------------------
if mpi.rank == 0:
    print '0 SIZE=%d'%mpi.size
sys.stdout.flush()
mpi.barrier()

# -----------------------------------------------
# stdout/stderr to console (English)
# -----------------------------------------------
print mpi.rank,'hello'
sys.stderr.write('%d %s\n'%(mpi.rank,'goodbye'))

# -----------------------------------------------
# stdout/stderr to /dev/null (Hungarian)
# -----------------------------------------------
mpi.synchronizeQueuedOutput('/dev/null','/dev/null')
print mpi.rank,"Jo'napot"
sys.stderr.write('%d %s\n'%(mpi.rank,'Viszontltsra'))

# -----------------------------------------------
# stdout/stderr to activated processor one at
# a time
# -----------------------------------------------
sys.stdout.flush()
mpi.barrier()
mpi.synchronizeQueuedOutput(None,None)
for rank in range(mpi.size):
    if mpi.rank == rank: 
        print mpi.rank,'HELLO'
    sys.stdout.flush()
    mpi.barrier()

sys.stderr.flush()
mpi.barrier()
mpi.synchronizeQueuedOutput(None,None)
for rank in range(mpi.size):
    if mpi.rank == rank: 
        sys.stderr.write('%d %s\n'%(mpi.rank,'GOODBYE'))
    sys.stderr.flush()
    mpi.barrier()

# -----------------------------------------------
# synchronizedWrite() (Texan)
# -----------------------------------------------
mpi.synchronizedWrite(mpi.rank,'howdy','\n')

# -----------------------------------------------
# stdout/stderr to queue files
# Test last since other syncs will flush
# any queued output
# -----------------------------------------------
mpi.synchronizeQueuedOutput('output','errput')
print mpi.rank,'hola'
sys.stderr.write('%d %s\n'%(mpi.rank,'adios'))

