# Get MPI if it is available
try:
    import mpi
    rank = mpi.rank
except:
    mpi = None
    rank = 0

from numpy.oldnumeric import ones,array
from pyMPI.pstencil import threepoint,set_sources,first

ZONES = 10
INITIAL_TEMPERATURE = 100
STEPS = 1

# Set the field to the initial temperature
T = ones(ZONES,'d')*INITIAL_TEMPERATURE

# define some sources
sources_index = array([0,   ZONES-1,])
sources_value = array([200, 0,      ])

# we distribute the field
if mpi is not None:
    T = mpi.scatter(T)
global_low = first(T)

# Deal with the boundaries
BC_left = INITIAL_TEMPERATURE-10
BC_right = INITIAL_TEMPERATURE+10

set_sources(sources_index,sources_value,T,global_low)
for i in range(STEPS):
    # Take a step
    threepoint(BC_left,T,BC_right)

    # Apply the sources
    set_sources(sources_index,sources_value,T,global_low)


if mpi is not None:
    T = mpi.gather(T)

if rank == 0:
    print T
